﻿// // ******************************************************************
// //       /\ /|       @File         iic_decoder.h
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-07-19
// //      /  \\        @Modified      2024-07-25
// //    *(__\_\
// // ******************************************************************

#pragma once
#include <string>
#include <vector>
#include "../BaseHelper//common_helper.h"

#include "iic_decode_options.h"
#include "iic_decode_result.h"
#include "iic_packet.h"
#include "protocol_iic_enums.h"
#include "../edge_pulse_data.h"

namespace Protocol
{
    struct EdgePulseDataTwoLevels;

    class IicDecoder
    {
    public:
        bool DecodeIic(const IicDecodeOptions& option, const EdgePulseDataTwoLevels& edge_pulses_clk,
                       const EdgePulseDataTwoLevels& edge_pulses_data, IicDecodeResult& result);

        std::vector<std::string> event_info_titles = {
            "Index", "Start Time", "Addr", "Data", "Error"
        };

    private:
        bool* is_cancel_ptr_ = nullptr;
        int32_t wave_data_len_ = 0;
        std::vector<IicEvent> packet_infos_;
        std::vector<IicDataInfo> packet_info_datas_;
        IicDecodeResult result_data_;

        IicEnums::DataBitWidth bit_width_ = IicEnums::DataBitWidth::DATA_BIT_WIDTH_7_BIT;

        static bool FindStartNode(int32_t& start_index, TwoLevelEdgePulse* node_sda,
                                  TwoLevelEdgePulse* node_scl);
        static bool FindStopNode(int32_t start_index, TwoLevelEdgePulse* node_sda,
                                 TwoLevelEdgePulse* node_scl, int32_t& stop_index);
    };
}
