﻿// // ******************************************************************
// //       /\ /|       @File         protocol_rs232_enums.h
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-06-26
// //      /  \\        @Modified      2024-07-16
// //    *(__\_\
// // ******************************************************************

#pragma once
#include "../edge_pulse.h"
#include "../BaseEnums/data_check_enums.h"

namespace Protocol
{
    class Rs232Enums
    {
    public:
        enum class Rs232DecodeEventType: int32_t
        {
            NONE,
            START,
            DATA,
            PARITY,
        };

        enum class DataBitWidth: int32_t
        {
            DATA_BIT_WIDTH_5_BIT = 5,
            DATA_BIT_WIDTH_6_BIT,
            DATA_BIT_WIDTH_7_BIT,
            DATA_BIT_WIDTH_8_BIT
        };


        enum class StopBit: int32_t
        {
            STOP_BIT_1_BIT,
            STOP_BIT_2_BIT
        };

        enum class BpsList: int32_t
        {
            BPS_LIST_2400,
            BPS_LIST_4800,
            BPS_LIST_9600,
            BPS_LIST_19200,
            BPS_LIST_38400,
            BPS_LIST_57600,
            BPS_LIST_115200,
            BPS_LIST_CUSTOM
        };
    };
}
