﻿// // ******************************************************************
// //       /\ /|       @File         XXX_decode_result.h
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-05-17
// //      /  \\        @Modified      2024-06-24
// //    *(__\_\
// // ******************************************************************

#pragma once
//#include <utility>

//#include "protocol_XXX_enums.h"

#include "xxx_decode_event.h"
#include "../decode_result.h"
//#include "XXX_packet.h"
//#include "../decode_event.h"

namespace Protocol
{
    class XXXDecodeResultCell : DecodeResultCell
    {


    };

    struct XXXDecodeResult //: DecodeResult
    {
        bool decode_result_need_update = false;
        bool decode_event_need_update = false;
        XXXDecodeResultCell* decode_result_cells_ptr; //解码数据结果指针
        XXXDecodeEvent* decode_events_ptr; //解码结果事件指针
        uint64_t decode_result_count; //结果数量
        uint64_t decode_event_count; //事件数量
        
        XXXDecodeResult() : decode_result_cells_ptr(nullptr), decode_events_ptr(nullptr), decode_result_count(0),
                            decode_event_count(0) 
                          
        {
            
        }
        XXXDecodeResult(const XXXDecodeResult& result)  
        {
            decode_result_need_update = result.decode_result_need_update;
            decode_event_need_update = result.decode_event_need_update;
            decode_result_cells_ptr = result.decode_result_cells_ptr;
            decode_events_ptr = result.decode_events_ptr;

            decode_result_count = result.decode_result_count;
            decode_event_count = result.decode_event_count;
        }
        ~XXXDecodeResult() = default;

        XXXDecodeResult(XXXDecodeResult&& other) noexcept
            : decode_result_need_update(other.decode_result_need_update),
              decode_event_need_update(other.decode_event_need_update),
              decode_result_cells_ptr(other.decode_result_cells_ptr),
              decode_events_ptr(other.decode_events_ptr),
              decode_result_count(other.decode_result_count),
              decode_event_count(other.decode_event_count) 

        {
        }
        XXXDecodeResult& operator=(const XXXDecodeResult& other)
        {
            if (this == &other) return *this;
            decode_result_need_update = other.decode_result_need_update;
            decode_event_need_update = other.decode_event_need_update;
            decode_result_cells_ptr = other.decode_result_cells_ptr;
            decode_events_ptr = other.decode_events_ptr;
            decode_result_count = other.decode_result_count;
            decode_event_count = other.decode_event_count;
            return *this;
        }
        XXXDecodeResult& operator=(XXXDecodeResult&& other) noexcept
        {
            if (this == &other) return *this;
            decode_result_need_update = other.decode_result_need_update;
            decode_event_need_update = other.decode_event_need_update;
            decode_result_cells_ptr = other.decode_result_cells_ptr;
            decode_events_ptr = other.decode_events_ptr;
            decode_result_count = other.decode_result_count;
            decode_event_count = other.decode_event_count;
            return *this;
        }
   
    };

}
