﻿// // ******************************************************************
// //       /\ /|       @File         quantize_params.h
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-05-16
// //      /  \\        @Modified      2024-06-24
// //    *(__\_\
// // ******************************************************************

#pragma once
#include <memory>
//#include <string>
#include <windows.h>

#include "edge_pulse.h"
#include "BaseEnums/quantized_enums.h"

namespace Protocol
{
    class QuantizeParams
    {
    public:
        //电平数量  目前第一步支持2、3电平2种
        QuantizedLevelOption level_option;

        // 电平阈值数组，用于存储多电平量化的阈值。
        // 数组的大小取决于所需的电平数量，例如，如果需要4个电平，则需要3个阈值。
        //单位 V
        std::vector<double> level_thresholds_by_v;

        // 量化位数
        int BitDepth;

        // 原始数据对象
        std::unique_ptr<byte> original_data;

        QuantizeParams();

        //拷贝构造函数  ljw 24.5
        QuantizeParams(const QuantizeParams& quantize_params);

        ~QuantizeParams();
    };
}
